library flutter_ui_toolkit;

import 'package:flutter/material.dart';

/// UIButton
class UIButton extends StatelessWidget {
  UIButton({
    this.label,
    this.onTap,
    this.icon,
    this.labelColor,
  });

  @required
  final String label;
  @required
  final Function onTap;
  final Color labelColor;
  final Widget icon;

  // Check if there is an icon
  bool hasIcon = icon != null;

  @override
  Widget build(BuildContext context) {
    return _buttonWrapper(
      child: hasIcon ? _buttonWithIcon : _label,
    );
  }

  Widget get _buttonWithIcon => _buttonWrapper(
        child: Row(
          mainAxisAlignment: MainAxisAlignment.spaceBetween,
          children: [
            _label,
            icon,
          ],
        ),
      );

  Widget get _label => UIHeading(
        label,
        color: labelColor,
      );

  Widget _buttonWrapper({Widget child}) {
    return Container(
      width: double.infinity,
      alignment: Alignment.centerLeft,
      child: GestureDetector(
        onTap: () => onTap,
        child: Padding(
          padding: const EdgeInsets.all(8.0),
          child: child,
        ),
      ),
    );
  }
}
